local M = {}
local device = nil
local timer = 0
local timer2 = 0
local timer3 = 0
local hasBeenActive = 0
local hasBeenActive2 = 0
local hasBeenActive3 = 0
local keySaveValue = 0

local function onInit()
    device = powertrain.getDevice("mainEngine")
    electrics.values["startermotor"] = 0
    electrics.values["startermotor2"] = 0
    electrics.values["startermotor3"] = 0
	hasBeenActive = 0
	hasBeenActive2 = 0
	hasBeenActive3 = 0
	electrics.values["key"] = 0
	keySaveValue = 0
end

local function onReset()
	electrics.values["startermotor"] = 0
    electrics.values["startermotor2"] = 0
    electrics.values["startermotor3"] = 0
	hasBeenActive = 0
	hasBeenActive2 = 0
	hasBeenActive3 = 0
	electrics.values["key"] = 0
	keySaveValue = 0
end

local function updateGFX(dt) 
  if device == nil then return end -- prevent lua error when engine removed
  if device.starterEngagedCoef == nil then return end
  if device.starterEngagedCoef ~= 0 and not device.isDisabled then 
	hasBeenActive = 1
	hasBeenActive2 = 1
	hasBeenActive3 = 1

    electrics.values["startermotor"] = 1
    electrics.values["startermotor2"] = 1
    electrics.values["startermotor3"] = 1

	--else
    --electrics.values["startermotor"] = 0
  end
  if hasBeenActive == 1 then
	timer = timer + dt		
	if timer >= 1.5 then
    electrics.values["startermotor"] = 0
	hasBeenActive = 0
	timer = 0
	end
  end
  if hasBeenActive2 == 1 then
	timer2 = timer2 + dt	
	if timer2 >= 2.5 then
    electrics.values["startermotor2"] = 0
	hasBeenActive2 = 0
	timer2 = 0
	end
  end
  if hasBeenActive3 == 1 then	
	timer3 = timer3 + dt	
	if timer3 >= 4.5 then
    electrics.values["startermotor3"] = 0
	hasBeenActive3 = 0
	timer3 = 0
	end
  end
  
 --car key twisting functions
 keySaveValue = electrics.values["key"]
 
  if device.starterEngagedCoef ~= 0 and not device.isDisabled then 

	if keySaveValue >= 1  then 
	
    electrics.values["key"] = 1
	
	elseif 1 < keySaveValue then
	
    electrics.values["key"] = electrics.values["key"] - 0.1
	
	elseif 1 > keySaveValue then
	
    electrics.values["key"] = electrics.values["key"] + 0.1
	
	end

  elseif electrics.values["engineRunning"] == 1 or electrics.values["lowbeam"] == 1 or electrics.values["highbeam"] == 1 or electrics.values["radio"] ~= "Radio Off" or electrics.values["domelight"] == 1 or electrics.values["ambient"] == 1 then

	if keySaveValue == 0.7 then 
	
    electrics.values["key"] = 0.7
	
	elseif keySaveValue > 0.75 then
	
    electrics.values["key"] = electrics.values["key"] - 0.1
	
	elseif keySaveValue < 0.7 then
	
    electrics.values["key"] = electrics.values["key"] + 0.1
	
	end

  else
  
    electrics.values["key"] = 0
  
  end
  
end

-- public interface
M.onInit = onInit
M.onReset = onReset
M.updateGFX = updateGFX

return M